/*
   charge density profile of point charges, both POLAR and nonpolar
   #included from slabmeas.c
*/
#ifdef POLAR
  if (si[i].chargepol==0)
    dpr[nspec+sp]->hist.dhist[nhsite]+=si[i].charge;
  else if (slabmode&8) {
    /* Drude charge density profile for short dipoles:
       using triangle (instead of rectangle) histogram bin
       algorithm changed in V3.4n */
    double zx=z*Grid+nbins-0.5;
    int nm=(int)zx;
    double dz=zx-nm;
    
    double zxD=zx+rpol[i][2]*Grid;
    int nmD=(int)zxD;
    double dzD=zxD-nmD;
    
    dpr[nspec+sp]->hist.dhist[nm%nbins]+=si[i].charge*(1-dz);
    dpr[nspec+sp]->hist.dhist[(nm+1)%nbins]+=si[i].charge*dz;
    
    dpr[nspec+sp]->hist.dhist[nmD%nbins]+=si[i].chargepol*(1-dzD);
    dpr[nspec+sp]->hist.dhist[(nmD+1)%nbins]+=si[i].chargepol*dzD; }
  else {
    /* charge density profile: Drude oscillator directly as 2 charges
       not good for very short dipoles */
    int ndrude=(z+rpol[i][2])*Grid;
    
    dpr[nspec+sp]->hist.dhist[nhsite]+=si[i].charge;
    dpr[nspec+sp]->hist.dhist[ndrude%nbins]+=si[i].chargepol; }
#else /*# POLAR */
  dpr[nspec+sp]->hist.dhist[nhsite]+=si[i].charge;
#endif /*#!POLAR */
